/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    refresh();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

// Load stats from source
// refresh UI
function refresh() {
    var url = "https://my.10g.kz/informer.php";
//    var url = "https://my.10g.kz/informer.php?debug=1&tip=109.238.162.226"; // 109.238.162.226 217.15.185.202
    var req = new XMLHttpRequest();
    
    req.open("GET", url, true);
    req.overrideMimeType("text/xml");
    req.onload = handleResponseLoad;
    req.send(null);
}

// Find node by tag name
function findNodeByTag(elt, tag, required) {
    var result;
    
    for (child = elt.firstChild; child != null; child = child.nextSibling) {
        if (child.nodeName == tag)
            return child;
    }
    
    if (required) {
        alert("Invalid XML document: <" + tag + "> not found");
    }

    return null;
}

function getNodeValue(elt, tag, is_required) {
    var node = findNodeByTag(elt, tag, is_required);
    
    if (node && node.firstChild) {
        return node.firstChild.nodeValue;
    }
    
    return null;
}

// response handler
function handleResponseLoad(e) {
    var req = e.target;
    
    if (!req.responseXML) {
        return displayError();
    }
    
    var data = { };
    
    var response = findNodeByTag(req.responseXML, "response", true);
    if (response == null)
        return displayError();
    
    if ((data.contract = getNodeValue(response, "contract", true)) == null)
        return displayError();
        
    if ((data.billing_model = getNodeValue(response, "billing-model", true)) == null)
        return displayError();
    
    if ((data.status = getNodeValue(response, "status", true)) == null)
        return displayError();

    if ((data.clientIP = getNodeValue(response, "client-ip", true)) == null)
        return displayError();
    
    if (data.billing_model == 'prepaid')
        data.remaining_days = getNodeValue(response, "remaining-days-count", false);
    
    data.balance = getNodeValue(response, "balance", false);
    
    var traffic = findNodeByTag(response, "traffic", false);
    if (traffic) {
        data.traffic = { 
            ibytes : getNodeValue(traffic, "ibytes", false),
            obytes : getNodeValue(traffic, "obytes", false)
        };
    }
    
    updateUI(data);
}

// format number value like this: XXX XXX.XX
function formatNumber(value) {
    var parts,
	collect = []; // symbols added here in reverse order (right-to-left)
		
    if (isNaN(value))
        value = 0.00;

    parts = value.toString().split('.');

    // format fraction part
    if (parts.length > 1) { // do we have fraction part at all ?
        if (parts[1].length < 2)
            collect.push('0');

        collect.push(parts[1].substr(0, 2)); // 
    } else {
        collect.push('00');
    }
    // decimal separator
    collect.push('.');

    // format integer part
    var idx, len = parts[0].length;
    for (idx = 0; idx < len; idx++) {
        if (idx != 0 && idx % 3 == 0) // add thousands separator
            collect.push(' ');
        collect.push(parts[0][len - idx - 1]);
    }
    
    return collect.reverse().join('');
}


// format traffic value into human readable form
// add unit suffixes (B, Kb, Mb, Gb, Tb) to reduce number of digits
function formatTrafficValue(value) {
    var units = ['Kb', 'Mb', 'Gb', 'Tb'];
    var unit = 'B';
    var i;

    if (value == undefined)
        return null;
    
    for (i = 0; i < units.length; i++) {
        if (value < 1024.0)
            break;
        unit = getLocalizedString(units[i]);
        value /= 1024.0;
    }
    
    value *= 100;
    value = Math.round(value) / 100;
    
    return formatNumber(value) + ' ' + unit;
}

function displayError() {
    var stateIndicator = document.getElementById('stateIndicator');
    stateIndicator.object.setValue(0);

    updateUIItem('txtContract', 'Comunication error');
    updateUIItem('txtBalance' , null);
    updateUIItem('txtDays'    , null);
    updateUIItem('txtITraffic', null);
    updateUIItem('txtOTraffic', null);
    updateUIItem('txtClientIP', null);

    alert("Comunication error. Can't load XML document");
}

// update UI item identified by id with value
function updateUIItem(id, value, formatter) {
    var elt = document.getElementById(id);
    if (elt) {
       elt.innerText = (formatter != undefined) ? formatter(value) : value;
    }
}

// update whole UI
function updateUI(data) {
    updateUIItem('txtContract', data.contract);
    updateUIItem('txtBalance' , data.balance, formatNumber);
    updateUIItem('txtITraffic', data.traffic.ibytes, formatTrafficValue);
    updateUIItem('txtOTraffic', data.traffic.obytes, formatTrafficValue);
    updateUIItem('txtClientIP', data.clientIP);

    var front = document.getElementById('front');
    front.setAttribute('class', 'billing-model-' + data.billing_model);
    
    if (data.billing_model == 'prepaid') {
        updateUIItem('txtDays', data.remaining_days);
    }

    var stateIndicator = document.getElementById('stateIndicator');
    var state = 3;
    
    if (data.status == 'online') {
        state = 1;
        if (data.billing_model == 'prepaid' && data.remaining_days <= 3)
            state = 2;
    }
    stateIndicator.object.setValue(state);
    
    var balance = document.getElementById('txtBalance');
    if (data.balance < 0) {
        Element.addClassName(balance, 'negative');
    } else {
        Element.removeClassName(balance, 'negative');
    }
}
